static const char file_id[] = "../../../../src/domains/cgc/stars/CGCPolarToRect.pl";
// .cc file generated from ../../../../src/domains/cgc/stars/CGCPolarToRect.pl by ptlang
/*
Copyright (c) 1990, 1991, 1992 The Regents of the University of California.
All rights reserved.
See the file ~ptolemy/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "KnownBlock.h"
#include "CGCPolarToRect.h"

const char *star_nm_CGCPolarToRect = "CGCPolarToRect";

const char* CGCPolarToRect :: className() const {return star_nm_CGCPolarToRect;}

Block* CGCPolarToRect :: makeNew() const { LOG_NEW; return new CGCPolarToRect;}

CodeBlock CGCPolarToRect :: body (
"	double m,p;\n"
"	m = $ref(magnitude);\n"
"	p = $ref(phase);\n"
"	$ref(x) = m * cos(p);\n"
"	$ref(y) = m * sin(p);\n"
);

CGCPolarToRect::CGCPolarToRect ()
{
	setDescriptor("Convert magnitude and phase to rectangular form.");
	addPort(magnitude.setPort("magnitude",this,FLOAT));
	addPort(phase.setPort("phase",this,FLOAT));
	addPort(x.setPort("x",this,FLOAT));
	addPort(y.setPort("y",this,FLOAT));

# line 31 "../../../../src/domains/cgc/stars/CGCPolarToRect.pl"
noInternalState();
}

void CGCPolarToRect::setup() {
# line 34 "../../../../src/domains/cgc/stars/CGCPolarToRect.pl"
addInclude("<math.h>");
}

void CGCPolarToRect::go() {
# line 44 "../../../../src/domains/cgc/stars/CGCPolarToRect.pl"
addCode(body);
}

// prototype instance for known block list
static CGCPolarToRect proto;
static KnownBlock entry(proto,"PolarToRect");
